let packages = require('./model').packages;
let cypher = require('./cypher');
let fs = require('fs');
let Promise = require('bluebird');

module.exports={
    create,
    getDetails,
    update,
    getContainerById
}

function create(container){
    /*
        {
            name:[file_name],
            data:{[JSON object]}
        }
     */
    return new Promise((resolve,reject)=>{
        try{
            let createWriteStream = fs.createWriteStream(`${__dirname}/packages/${container.name}.json`);

            createWriteStream.write(cypher.encrypt(JSON.stringify(container)));
            createWriteStream.close();
            
            packages.create({
                name: container.name,
                data_path: `${__dirname}/packages/${container.name}.json`
            })
            .then(result=>{
                resolve(result);
            })
            .catch(err=>{
                reject(err);
            })
        }
        catch(e){
            reject(e);
        }
    });
}

function getDetails(containerName){
    return new Promise((resolve,reject)=>{
        try{
            //require to bcrypt the contents in setters and getters
                let container = fs.readFileSync(`${__dirname}/packages/${containerName}.json`,'utf8');
                resolve(cypher.decrypt(container));
        }
        catch(err){
            reject(err);
        }
    });
    
}

function getContainerById(containerId){
    return new Promise((resolve,reject)=>{
        packages.findById(containerId)
        .then(r=>{
            resolve(r);
        })
        .catch(err=>{
            reject(err);
        })
    });
}

async function update(id,container){
    await fs.unlink(`${__dirname}/packages/${container.name}.json`, (err) => {
        if (err) throw err;
        console.log('container was deleted');
        let createWriteStream = fs.createWriteStream(`${__dirname}/packages/${container.name}.json`);
        createWriteStream.pipe(cypher.encypt(JSON.stringify(container)));
        createWriteStream.close();
      });

    await packages.find({where:{id:id}})
    .then(findResult=>{
        packages.update(
            {
                name:container.name,
                data_path:`${__dirname}/packages/${container.name}.json`
            },
            {
                    where:{id:findResult.id}
            })
        .then(result=>{
            console.log("updated");
            process.exit();
        })
    })
    .catch(err=>{
        throw err;
    })
}