'use strict';
module.exports = (sequelize, DataTypes) => {
  let queuedItem = sequelize.define('queuedItem', {
    name: {
      type:DataTypes.STRING,
      allowNull:false
    },
    order: {
      type:DataTypes.INTEGER,
      allowNull:false
    },
    status: {
      type:DataTypes.STRING,
      allowNull:false
    },
    performers:{
      type:DataTypes.INTEGER,
      allowNull:false
    },
    wfId: {
      type:DataTypes.INTEGER,
      allowNull:false
    },
    acl: {
      type:DataTypes.INTEGER,
      allowNull:false
    },
    packages: {
      type:DataTypes.INTEGER,
      allowNull:true
    },
    methods: {
      type:DataTypes.INTEGER,
      allowNull:false
    }
  });
  queuedItem.associate = function(models) {
    // associations can be defined here
    queuedItem.hasOne(models.packages,{
      foreignKey:"packages",
      // as:"activity_package"
    });

    queuedItem.belongsTo(models.methods,{
      foreignKey:"methods",
      targetKey:"id",
      // as:"activity_method"
    });
    
    queuedItem.belongsTo(models.process,{
      foreignKey:"wfId",
      targetKey:"id",
      // as:"activity_workflow"
    });

    queuedItem.belongsTo(models.performers,{
      foreignKey:"performers",
      targetKey:"id",
      // as:"activity_performer"
    });

    queuedItem.belongsTo(models.workflow_acl,{
      foreignKey:"acl",
      targetKey:"id",
      // as:"activity_acl"
    });
  };
  return queuedItem;
};